<?php



/**
* @author    mlunzena
* @copyright (c) Authors
* @version   $Id: APCCachePlugin.class.php 400 2007-09-07 13:55:24Z mlunzena $
*/

class FileCachePlugin extends AbstractStudIPAdministrationPlugin {
	
	
	const CACHE_CLASS = 'StudipFileCache';
	const CACHE_FILE  = 'StudipFileCache.class.php';
	const DOMAIN      = 'FileCachePlugin';
	
	
	function __construct() {
		
		parent::AbstractStudIPAdministrationPlugin();
		
		$this->setPluginiconname("img/plugin.png");
		
		# navigation
		$navigation = new PluginNavigation();
		$navigation->setDisplayname(self::CACHE_CLASS . '-' .
		dgettext(self::DOMAIN, 'Konfiguration'));
		$this->setNavigation($navigation);
	}
	
	
	function getPluginname() {
		return self::CACHE_CLASS . '-' . dgettext(self::DOMAIN, 'Konfiguration');
	}
	
	
	function setActivated($value = FALSE, $requestedbyuser = FALSE){
		parent::setActivated($value, $requestedbyuser);
		
		if (FALSE === $value && $this->cache_enabled()) {
			StudipCacheFactory::unconfigure();
		}
	}
	
	
	function actionShow() {
		
		$factory = new Flexi_TemplateFactory(dirname(__FILE__).'/templates');
		
		$domain = self::DOMAIN;
		
		
		$message = array();
		
		# form were submitted
		if ('POST' == $_SERVER['REQUEST_METHOD']) {
			
			# activate cache
			if (isset($_POST['activate'])) {
				StudipCacheFactory::configure(dirname(__FILE__) . '/' .
				self::CACHE_FILE,
				self::CACHE_CLASS,
				array());
				$message[] = dgettext(self::DOMAIN, 'Cache fr Stud.IP aktiviert.');
			}
			
			# deactivate cache
			if (isset($_POST['deactivate'])) {
				StudipCacheFactory::unconfigure();
				$message[] = dgettext(self::DOMAIN,
				'Cache fr Stud.IP deaktiviert.');
			}
			
			if (isset($_POST['configure'])) {
				$dir = trim(stripslashes($_REQUEST['cache_dir']));
				if($dir != $GLOBALS['TMP_PATH'] . DIRECTORY_SEPARATOR . 'studip_cache'. DIRECTORY_SEPARATOR){
					StudipCacheFactory::configure(dirname(__FILE__) . '/' .
					self::CACHE_FILE,
					self::CACHE_CLASS,
					array(array('dir' => $dir)));
					$message[] = dgettext(self::DOMAIN, 'Cache Verzeichnis gendert.');
				}
			}
		}
		try {
			$cache = StudipCacheFactory::getCache();
		} catch (Exception $e) {
			$message[] = "Cache konnte nicht aktiviert werden: " . $e->getMessage();
			StudipCacheFactory::unconfigure();
				$message[] = dgettext(self::DOMAIN,
				'Cache fr Stud.IP deaktiviert.');
			$cache = StudipCacheFactory::getCache();
		}
		if(is_object($cache)){
			$current_cache_class = get_class($cache);
			$enabled = $this->cache_enabled();
			$extension = self::CACHE_CLASS;
			if($cache instanceof  StudipFileCache ) $cache_dir = $cache->getCacheDir();
		}
		echo $factory->render('form',
		compact('message', 'enabled', 'current_cache_class', 'domain', 'extension','cache_dir'));
	}
	
	
	private function cache_enabled() {
		$cache = StudipCacheFactory::getCache();
		return get_class($cache) == self::CACHE_CLASS;
	}
}
